

#ifndef __EPPI_H__
#define __EPPI_H__

/*************************************************************************************************************************
									Function Prototypes
**************************************************************************************************************************/
/*This function acts as ISR for  EPPI0 DMA channel completion interrupt*/
void EPPI0_Interrupt_Handler (uint32_t iid, void* handlerArg);

/*This function initializes the value of EPPI Control and Clock_Div registers.*/
void EPPI_Control_Config(unsigned int uiPID, unsigned int uiEPPI_CTL, unsigned int uiEPPI_CTL2, unsigned int uiEPPI_CLKDIV);

/*This function initializes the value of EPPI Frame sync delay registers to generate delayed frame sync.*/
void EPPI_FSDelay_Config(unsigned int uiPID, unsigned int uiEPPI_FS1_DLY, unsigned int uiEPPI_FS2_DLY);

/*This function initializes the value of EPPI Frame sync width and period registers to generate internal frame syncs.*/
void EPPI_FSync_Config(unsigned int uiPID, unsigned int uiEPPI_FS1_WLHB, unsigned int uiEPPI_FS1_PASPL, unsigned int uiEPPI_FS2_WLVB , unsigned int uiEPPI_FS2_PALPF );

/*This function initializes the value of EPPI Line, HCNT and HDelay registers.*/
void EPPI_Line_Config(unsigned int uiPID, unsigned int uiEPPI_LINE, unsigned int uiEPPI_HCNT, unsigned int uiEPPI_HDLY);

/*This function initializes the value of EPPI FRAME, VCNT and VDelay registers.*/
void EPPI_Frame_Config(unsigned int uiPID, unsigned int uiEPPI_FRAME, unsigned int uiEPPI_VCNT, unsigned int uiEPPI_VDLY);

/*This function initializes the value of EPPI IMASK register for enabling the interrupts.*/
void EPPI_IMASK_Config(unsigned int uiPID, unsigned int uiEPPI_IMSK );

/*This function initializes the value of EPPI Even and Odd clipping registers.*/
void EPPI_Clip_Config(unsigned int uiPID, unsigned int uiEPPI_ODDCLIP, unsigned int uiEPPI_EVENCLIP);

/*This function Enables(starts) the EPPI module.*/
void EPPI_Enable(unsigned int uiPID);

/*This function initializes the DMA channel for corresponding EPPI*/
void EPPI_DMANormal_Config(unsigned int uiPID, int* iBufferAddress, int iXModifier, unsigned int uiXSize, int iYModifier, unsigned int uiYSize, unsigned int uiDMAConfig);

#endif
