/*****************************************************************************
 * Stress_Test1_Core0.h
 *****************************************************************************/

#ifndef __STRESS_TEST1_CORE0_H__
#define __STRESS_TEST1_CORE0_H__

#include "adi_initialize.h"
#include <sys/platform.h>
#include <sys/adi_core.h>
#include "time.h"
#include "stdio.h"
#include "EPPI.h"

/* Macro to configure MDMA */
#define MDMA_CONFIG(S_MDMA_CHANNEL,S_CFG, S_ADDRSTART, S_MOD, S_COUNT,D_MDMA_CHANNEL,D_CFG, D_ADDRSTART, D_MOD, D_COUNT)\
		*pREG_DMA##S_MDMA_CHANNEL##_CFG = S_CFG;\
		*pREG_DMA##S_MDMA_CHANNEL##_ADDRSTART = S_ADDRSTART;\
		*pREG_DMA##S_MDMA_CHANNEL##_XCNT = S_COUNT;\
		*pREG_DMA##S_MDMA_CHANNEL##_XMOD = S_MOD;\
		*pREG_DMA##D_MDMA_CHANNEL##_CFG = D_CFG;\
		*pREG_DMA##D_MDMA_CHANNEL##_ADDRSTART = D_ADDRSTART;\
		*pREG_DMA##D_MDMA_CHANNEL##_XCNT = D_COUNT;\
		*pREG_DMA##D_MDMA_CHANNEL##_XMOD = D_MOD;\
		*pREG_DMA##D_MDMA_CHANNEL##_CFG|= 0x1;\
		*pREG_DMA##S_MDMA_CHANNEL##_CFG|= 0x1;

/* Macro to disable the MDMAs */
#define DISABLE_MDMAs(S_MDMA_CHANNEL, D_MDMA_CHANNEL)\
		*pREG_DMA##S_MDMA_CHANNEL##_CFG = 0;\
		*pREG_DMA##D_MDMA_CHANNEL##_CFG = 0;

/* Macro to disable PPIDMA */
#define DISABLE_PPI_DMA(DMA_CHANNEL)\
		*pREG_DMA##DMA_CHANNEL##_CFG = 0;

/* Macro to enable peripheral DMA */
#define PDMA_CONFIG(PDMA_CHANNEL,S_CFG, S_ADDRSTART, S_MOD, S_COUNT)\
		*pREG_DMA##PDMA_CHANNEL##_CFG = S_CFG;\
		*pREG_DMA##PDMA_CHANNEL##_ADDRSTART = S_ADDRSTART;\
		*pREG_DMA##PDMA_CHANNEL##_XCNT = S_COUNT;\
		*pREG_DMA##PDMA_CHANNEL##_XMOD = S_MOD;\
		*pREG_DMA##PDMA_CHANNEL##_CFG|= 0x1;

#define ENABLE_PPI0_DMA_168_75MBPS
#define ENABLE_MDMA0_DMA_2000MBPS
#define ENABLE_MDMA1_DMA_2000MBPS
#define ENABLE_MDMA2_DMA_2000MBPS
#define ENABLE_MDMA3_DMA_4000MBPS
#define ENABLE_MDMA4_DMA_2000MBPS
#define ENABLE_MDMA5_DMA_2000MBPS

#define PAGE_SIZE 		2048
#define ROWS_PER_BANK 	16384
#define BANK_SIZE 		PAGE_SIZE*ROWS_PER_BANK

#define SOURCE_MSIZE_MDMA0 32

//#define T0
//#define T1
//#define T2
//#define T3
#define T4

#ifdef T0
#define USE_SINGLE_BANK
#endif

#ifdef T1
#define USE_MULTIPLE_BANKS
#endif

#if defined (__ADSPSC598__)

#ifdef T2
#define USE_MULTIPLE_BANKS
#define LIMIT_MDMA0_BW 200
#define LIMIT_MDMA1_BW 100
#define LIMIT_MDMA2_BW 200
#define LIMIT_MDMA3_BW 300
#define LIMIT_MDMA4_BW 150
#define LIMIT_MDMA5_BW 100
#endif

#ifdef T3
#define USE_MULTIPLE_BANKS
#define LIMIT_MDMA0_BW 150
#define LIMIT_MDMA1_BW 200
#define LIMIT_MDMA2_BW 100
#define LIMIT_MDMA3_BW 200
#define LIMIT_MDMA4_BW 200
#define LIMIT_MDMA5_BW 200
#endif

#ifdef T4
#define USE_MULTIPLE_BANKS
#define LIMIT_MDMA0_BW 100
#define LIMIT_MDMA1_BW 75
#define LIMIT_MDMA2_BW 300
#define LIMIT_MDMA3_BW 400
#define LIMIT_MDMA4_BW 100
#define LIMIT_MDMA5_BW 75
#endif

#elif defined (__ADSPSC594__)

#ifdef T2
#define USE_MULTIPLE_BANKS
#define LIMIT_MDMA0_BW 100
#define LIMIT_MDMA1_BW 100
#define LIMIT_MDMA2_BW 100
#define LIMIT_MDMA3_BW 100
#define LIMIT_MDMA4_BW 100
#define LIMIT_MDMA5_BW 100
#endif

#ifdef T3
#define USE_MULTIPLE_BANKS
#define LIMIT_MDMA0_BW 75
#define LIMIT_MDMA1_BW 75
#define LIMIT_MDMA2_BW 100
#define LIMIT_MDMA3_BW 200
#define LIMIT_MDMA4_BW 75
#define LIMIT_MDMA5_BW 75
#endif

#ifdef T4
#define USE_MULTIPLE_BANKS
#define LIMIT_MDMA0_BW 50
#define LIMIT_MDMA1_BW 50
#define LIMIT_MDMA2_BW 150
#define LIMIT_MDMA3_BW 250
#define LIMIT_MDMA4_BW 50
#define LIMIT_MDMA5_BW 50
#endif

#endif

#ifdef USE_MULTIPLE_BANKS
	#define PPI0_DMA_DMC_START_ADDRESS  0x80000000+0*BANK_SIZE
	#define MDMA2_DMA_DMC_START_ADDRESS 0x80000000+1*BANK_SIZE
	#define MDMA3_DMA_DMC_START_ADDRESS 0x80000000+2*BANK_SIZE
	#define MDMA1_DMA_DMC_START_ADDRESS 0x80000000+3*BANK_SIZE
	#define MDMA0_DMA_DMC_START_ADDRESS 0x80000000+4*BANK_SIZE
	#define MDMA4_DMA_DMC_START_ADDRESS 0x80000000+5*BANK_SIZE
	#define MDMA5_DMA_DMC_START_ADDRESS 0x80000000+6*BANK_SIZE
#endif

#ifdef USE_SINGLE_BANK
	#define PPI0_DMA_DMC_START_ADDRESS	0x80000000
	#define MDMA2_DMA_DMC_START_ADDRESS 0x80000000+4*1*PAGE_SIZE*4
	#define MDMA3_DMA_DMC_START_ADDRESS 0x80000000+4*2*PAGE_SIZE*4
	#define MDMA1_DMA_DMC_START_ADDRESS 0x80000000+4*3*PAGE_SIZE*4
	#define MDMA0_DMA_DMC_START_ADDRESS 0x80000000+4*4*PAGE_SIZE*4
	#define MDMA4_DMA_DMC_START_ADDRESS 0x80000000+4*5*PAGE_SIZE*4
	#define MDMA5_DMA_DMC_START_ADDRESS 0x80000000+4*6*PAGE_SIZE*4
#endif


#define SOURCE_MDMA_CHANNEL 18
#define DEST_MDMA_CHANNEL 	19


#define SOURCE_PSIZE_MDMA0 		 4
#define DEST_PSIZE_MDMA0   		 4
#define SOURCE_MSIZE_MDMA0		 32
#define DEST_MSIZE_MDMA0  		 32
#define SOURCE_DMA_CFG_MDMA0 	 ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_PSIZE04|ENUM_DMA_CFG_XCNT_INT|ENUM_DMA_CFG_AUTO
#define DEST_DMA_CFG_MDMA0		 BITM_DMA_CFG_WNR|ENUM_DMA_CFG_PSIZE04|ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_XCNT_INT|ENUM_DMA_CFG_AUTO


#define SOURCE_PSIZE_MDMA1 		 4
#define DEST_PSIZE_MDMA1   		 4
#define SOURCE_MSIZE_MDMA1		 32
#define DEST_MSIZE_MDMA1  		 32
#define SOURCE_DMA_CFG_MDMA1 	 ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_PSIZE04|ENUM_DMA_CFG_XCNT_INT|ENUM_DMA_CFG_AUTO
#define DEST_DMA_CFG_MDMA1		 BITM_DMA_CFG_WNR|ENUM_DMA_CFG_PSIZE04|ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_XCNT_INT|ENUM_DMA_CFG_AUTO


#define SOURCE_PSIZE_MDMA2 		 4
#define DEST_PSIZE_MDMA2   		 4
#define SOURCE_MSIZE_MDMA2		 32
#define DEST_MSIZE_MDMA2  		 32
#define SOURCE_DMA_CFG_MDMA2 	 ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_PSIZE04|ENUM_DMA_CFG_XCNT_INT|ENUM_DMA_CFG_AUTO
#define DEST_DMA_CFG_MDMA2		 BITM_DMA_CFG_WNR|ENUM_DMA_CFG_PSIZE04|ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_XCNT_INT|ENUM_DMA_CFG_AUTO


#define SOURCE_PSIZE_MDMA3		 8
#define DEST_PSIZE_MDMA3   		 8
#define SOURCE_MSIZE_MDMA3 		 32
#define DEST_MSIZE_MDMA3   		 32
#define SOURCE_DMA_CFG_MDMA3 	 ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_PSIZE08|ENUM_DMA_CFG_XCNT_INT|ENUM_DMA_CFG_AUTO
#define DEST_DMA_CFG_MDMA3 		 BITM_DMA_CFG_WNR|ENUM_DMA_CFG_PSIZE08|ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_XCNT_INT|ENUM_DMA_CFG_AUTO


#define SOURCE_PSIZE_MDMA4 		 4
#define DEST_PSIZE_MDMA4   		 4
#define SOURCE_MSIZE_MDMA4		 32
#define DEST_MSIZE_MDMA4  		 32
#define SOURCE_DMA_CFG_MDMA4 	 ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_PSIZE04|ENUM_DMA_CFG_XCNT_INT|ENUM_DMA_CFG_AUTO
#define DEST_DMA_CFG_MDMA4		 BITM_DMA_CFG_WNR|ENUM_DMA_CFG_PSIZE04|ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_XCNT_INT|ENUM_DMA_CFG_AUTO


#define SOURCE_PSIZE_MDMA5 		 4
#define DEST_PSIZE_MDMA5   		 4
#define SOURCE_MSIZE_MDMA5		 32
#define DEST_MSIZE_MDMA5  		 32
#define SOURCE_DMA_CFG_MDMA5 	 ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_PSIZE04|ENUM_DMA_CFG_XCNT_INT|ENUM_DMA_CFG_AUTO
#define DEST_DMA_CFG_MDMA5		 BITM_DMA_CFG_WNR|ENUM_DMA_CFG_PSIZE04|ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_XCNT_INT|ENUM_DMA_CFG_AUTO


#define CCLK_SPEED 		1000
#define SYSCLK_SPEED 	500.0
#define SCLK_SPEED 		125.0

#define MAX_SIZE 		4*PAGE_SIZE

#define PPI0_PSIZE 		4
#define PPI0_MSIZE 		32
#define PPI0_DMA_CFG 	ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_PSIZE04|ENUM_DMA_CFG_XCNT_INT|ENUM_DMA_CFG_AUTO

#define EPPI0_CTL_CFG 	ENUM_EPPI_CTL_TXMODE|ENUM_EPPI_CTL_NON656|ENUM_EPPI_CTL_INTCLK|ENUM_EPPI_CTL_INTFS|ENUM_EPPI_CTL_DLEN24|ENUM_EPPI_CTL_PACK_EN|ENUM_EPPI_CTL_EN
#define EPPI0_CTL2_CFG 	0

#endif
